package com.arosii.jmeter.protocol.ihe.control.gui;

import java.awt.Component;

import javax.swing.BorderFactory;
import javax.swing.JPanel;

import org.apache.jmeter.gui.util.VerticalPanel;
import org.apache.jmeter.testelement.TestElement;
import org.apache.jmeter.util.JMeterUtils;

import com.arosii.jmeter.protocol.ihe.sampler.OpretAftaleSampler;
import com.arosii.jmeter.resources.aftaler.Messages;

public class OpretAftaleSamplerGUI extends ITI41SamplerGUI {

	/**
	 * {@inheritDoc}
	 */
	@Override
	public String getStaticLabel() {
		String label = Messages.getResString(getLabelResource());
		if (label == null || label.startsWith(JMeterUtils.RES_KEY_PFX)) {
			label = super.getStaticLabel();
		}
		return label;
	}

	@Override
	public String getLabelResource() {
		return "opret_aftale_request";
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public TestElement createTestElement() {
		OpretAftaleSampler sampler = new OpretAftaleSampler();
		modifyTestElement(sampler);
		return sampler;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	protected Component createConfigurationPanel() {
		final VerticalPanel configurationPanel = new VerticalPanel();
		appendMessageHeadersPanel(configurationPanel);
		appendFilePanel(configurationPanel);
		appendServiceTimePanel(configurationPanel);
		appendCodesPanel(configurationPanel);
		return configurationPanel;
	}

	protected void appendTitlePanel(VerticalPanel configurationPanel) {
		JPanel panel = new VerticalPanel();
		panel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(), Messages.getResString("ihe_iti41_file_panel")));
		panel.add(getTitlePanel());
		configurationPanel.add(panel);
	}
}
