/*
 * The contents of this file is the CONFIDENTAL and PROPRIETARY
 * property of Arosii Information Systems A/S. Any unauthorized use,
 * reproduction or transfer of this file is strictly prohibited.
 *
 * Copyright (C) 2012 Arosii Information Systems A/S.  All rights reserved.
 * This is an unpublished work, and is subject to limited
 * distribution and restricted disclosure only.
 */
package com.arosii.jmeter.control.gui;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.AbstractButton;
import javax.swing.JComponent;

public class ButtonClicker extends MouseAdapter {

	private final AbstractButton button;

	private final JComponent component;

	public ButtonClicker(AbstractButton button, JComponent component) {
		this.button = button;
		this.component = component;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public void mouseClicked(MouseEvent e) {
		if (!button.isSelected()) {
			button.doClick();
			if (component != null) {
				component.requestFocus();
			} else {
				button.requestFocus();
			}
		}
	}
}
