/*
 * The contents of this file is the CONFIDENTIAL and PROPRIETARY
 * property of Arosii A/S. Any unauthorized use, reproduction
 * or transfer of this file is strictly prohibited.
 * 
 * Copyright (C) 2012 Arosii A/S. All rights reserved.
 * This is an unpublished work, and is subject to limited
 * distribution and restricted disclosure only.
 */
package com.arosii.jmeter.protocol.nsp.control.gui;

import java.awt.BorderLayout;
import java.awt.Component;

import org.apache.jmeter.samplers.gui.AbstractSamplerGui;
import org.apache.jmeter.testelement.TestElement;
import org.apache.jmeter.util.JMeterUtils;

import com.arosii.jmeter.resources.nsp.Messages;

/**
 * 
 * @author jacob
 */
public abstract class AbstractNSPSamplerGui extends AbstractSamplerGui {

	private static final long serialVersionUID = 1L;

	public AbstractNSPSamplerGui() {
		// Standard setup
		setLayout(new BorderLayout(0, 5));
		setBorder(makeBorder());
		add(makeTitlePanel(), BorderLayout.NORTH); // Add the standard title

		// Specific setup
		add(createConfigurationPanel(), BorderLayout.CENTER);
	}

	/**
	 * @return the configuration panel
	 */
	protected abstract Component createConfigurationPanel();

	/**
	 * {@inheritDoc}
	 */
	@Override
	public String getStaticLabel() {
		String label = Messages.getResString(getLabelResource());
		if (label == null || label.startsWith(JMeterUtils.RES_KEY_PFX)) {
			label = super.getStaticLabel();
		}
		return label;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public void modifyTestElement(TestElement element) {
		element.clear();
		configureTestElement(element);
	}

}
