/*
 * The contents of this file is the CONFIDENTAL and PROPRIETARY
 * property of Arosii Information Systems A/S. Any unauthorized use,
 * reproduction or transfer of this file is strictly prohibited.
 *
 * Copyright (C) 2012 Arosii Information Systems A/S.  All rights reserved.
 * This is an unpublished work, and is subject to limited
 * distribution and restricted disclosure only.
 */
package com.arosii.jmeter.protocol.nsp.processor;

import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.ConcurrentMap;

/**
 * 
 * @author Jacob
 */
public class SharedObjects {

	private static final ConcurrentMap<String, Object> share = new ConcurrentHashMap<String, Object>();
	
	public static void clear() {
		share.clear();
	}

	public static void put(String key, Object object) {
		if (object != null) {
			share.put(key, object);
		} else {
			share.remove(key);
		}
	}
	
	public static Object get(String key) {
		return share.get(key);
	}
	
}
