/*
 * The contents of this file is the CONFIDENTAL and PROPRIETARY
 * property of Arosii Information Systems A/S. Any unauthorized use,
 * reproduction or transfer of this file is strictly prohibited.
 *
 * Copyright (C) 2012 Arosii Information Systems A/S.  All rights reserved.
 * This is an unpublished work, and is subject to limited
 * distribution and restricted disclosure only.
 */
package com.arosii.jmeter.protocol.nsp.processor.gui;

import java.awt.BorderLayout;
import java.awt.Component;

import javax.swing.JPanel;

import org.apache.jmeter.processor.gui.AbstractPostProcessorGui;
import org.apache.jmeter.testelement.TestElement;
import org.apache.jmeter.util.JMeterUtils;

import com.arosii.jmeter.resources.nsp.Messages;

/**
 * 
 * @author Jacob
 */
public abstract class AbstractNSPPostProcessorGui extends AbstractPostProcessorGui {

	private static final long serialVersionUID = 1L;

	public AbstractNSPPostProcessorGui() {
		// Standard setup
		setLayout(new BorderLayout(0, 5));
		setBorder(makeBorder());
		add(makeTitlePanel(), BorderLayout.NORTH); // Add the standard title

		// Specific setup
		add(createConfigurationPanel(), BorderLayout.CENTER);
	}

	/**
	 * @return the configuration panel
	 */
	protected abstract Component createConfigurationPanel();

	/**
	 * Append the scope panel to the configuration panel
	 */
	protected void appendScopePanel(JPanel configurationPanel) {
        configurationPanel.add(createScopePanel(true));
	}
	
	/**
	 * {@inheritDoc}
	 */
	@Override
	public String getStaticLabel() {
		String label = Messages.getResString(getLabelResource());
		if (label == null || label.startsWith(JMeterUtils.RES_KEY_PFX)) {
			label = super.getStaticLabel();
		}
		return label;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public void modifyTestElement(TestElement element) {
		element.clear();
		configureTestElement(element);
	}

}
