/*
 * The contents of this file is the CONFIDENTAL and PROPRIETARY
 * property of Arosii Information Systems A/S. Any unauthorized use,
 * reproduction or transfer of this file is strictly prohibited.
 *
 * Copyright (C) 2012 Arosii Information Systems A/S.  All rights reserved.
 * This is an unpublished work, and is subject to limited
 * distribution and restricted disclosure only.
 */
package com.arosii.jmeter.protocol.nsp.sampler.gui;

import java.awt.BorderLayout;
import java.awt.Component;

import javax.swing.BorderFactory;
import javax.swing.JPanel;
import javax.swing.JTextArea;

import org.apache.jmeter.gui.util.VerticalPanel;
import org.apache.jmeter.testelement.TestElement;

import com.arosii.jmeter.protocol.nsp.control.gui.AbstractNSPSamplerGui;
import com.arosii.jmeter.protocol.nsp.sampler.EchoSampler;
import com.arosii.jmeter.resources.nsp.Messages;

/**
 * 
 * @author Jacob
 */
public class EchoSamplerGui extends AbstractNSPSamplerGui {

	private static final long serialVersionUID = 1L;

	private JTextArea data;

	/**
	 * {@inheritDoc}
	 */
	@Override
	public String getLabelResource() {
		return "nsp_echo";
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public TestElement createTestElement() {
		EchoSampler sampler = new EchoSampler();
		modifyTestElement(sampler);
		return sampler;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	protected Component createConfigurationPanel() {
		final VerticalPanel configurationPanel = new VerticalPanel();
		appendDataPanel(configurationPanel);
		return configurationPanel;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public void configure(TestElement element) {
		super.configure(element);
		data.setText(element.getPropertyAsString(EchoSampler.XML_DATA, ""));
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public void modifyTestElement(TestElement element) {
		super.modifyTestElement(element);
		element.setProperty(EchoSampler.XML_DATA, data.getText());
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public void clearGui() {
		super.clearGui();
		data.setText("");
	}

	private void appendDataPanel(VerticalPanel configurationPanel) {
		JPanel dataPanel = new VerticalPanel();
		dataPanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(), Messages.getResString("nsp_echo_data")));
		dataPanel.add(getDataPanel());
		configurationPanel.add(dataPanel);
	}

	private JPanel getDataPanel() {
		data = new JTextArea();

		JPanel panel = new JPanel(new BorderLayout(5, 0));
		panel.add(data, BorderLayout.CENTER);

		return panel;
	}
}
