/*
 * The contents of this file is the CONFIDENTAL and PROPRIETARY
 * property of Arosii Information Systems A/S. Any unauthorized use,
 * reproduction or transfer of this file is strictly prohibited.
 *
 * Copyright (C) 2012 Arosii Information Systems A/S.  All rights reserved.
 * This is an unpublished work, and is subject to limited
 * distribution and restricted disclosure only.
 */
package com.arosii.jmeter.utils.nsp.sync;

import java.io.IOException;
import java.io.InputStream;
import java.io.PrintStream;
import java.net.InetAddress;
import java.net.Socket;

/**
 * 
 * @author Jacob
 */
public class SyncSlave {

	private static final int ONE_MINUTE = 1000 * 60;

	public static void main(String[] args) throws Exception {
		Long start = System.currentTimeMillis();
		String host = args[0];
		Integer port = Integer.valueOf(args[1]);
		Socket socket = null;
		int timeout = Integer.valueOf(args[2]) * ONE_MINUTE;
		while (System.currentTimeMillis() < start + timeout) {
			try {
				socket = new Socket(host, port);
				break;
			} catch (IOException e) {
				synchronized (start) {
					start.wait(15 * 1000);
				}
			}
		}
		if (socket != null) {
			InputStream in = socket.getInputStream();
			PrintStream out = new PrintStream(socket.getOutputStream());
			out.println(InetAddress.getLocalHost().getHostName() + ":" + socket.getLocalPort());
			out.flush();
			System.out.println("Waiting for signal from the master at " + socket.getRemoteSocketAddress());
			int status = in.read();
			System.out.println("Signal received");
			socket.close();
			System.exit(status);
		} else {
			System.err.println("Could not connect to " + host + ":" + port);
			System.exit(1);
		}
	}

}
