/*
 * The contents of this file is the CONFIDENTAL and PROPRIETARY
 * property of Arosii Information Systems A/S. Any unauthorized use,
 * reproduction or transfer of this file is strictly prohibited.
 *
 * Copyright (C) 2012 Arosii Information Systems A/S.  All rights reserved.
 * This is an unpublished work, and is subject to limited
 * distribution and restricted disclosure only.
 */
package com.arosii.jmeter.visualizers.gui;

import org.apache.jmeter.util.JMeterUtils;
import org.apache.jmeter.visualizers.SummaryReport;

import com.arosii.jmeter.reporters.ThroughputResultCollector;
import com.arosii.jmeter.resources.nsp.Messages;

/**
 *
 * @author Jacob
 */
public class ThroughputSummaryReport extends SummaryReport {

	private static final long serialVersionUID = 1L;

	public ThroughputSummaryReport() {
		super();
		setModel(new ThroughputResultCollector());
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public String getLabelResource() {
		return "nsp_throughput_summary_report";
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public String getStaticLabel() {
		String label = Messages.getResString(getLabelResource());
		if (label == null || label.startsWith(JMeterUtils.RES_KEY_PFX)) {
			label = super.getStaticLabel();
		}
		return label;
	}
}
