/*
 * The contents of this file is the CONFIDENTAL and PROPRIETARY
 * property of Arosii Information Systems A/S. Any unauthorized use,
 * reproduction or transfer of this file is strictly prohibited.
 *
 * Copyright (C) 2012 Arosii Information Systems A/S.  All rights reserved.
 * This is an unpublished work, and is subject to limited
 * distribution and restricted disclosure only.
 */
package com.arosii.jmeter.protocol.dcc.processor;

import org.apache.jmeter.samplers.Sampler;

import com.arosii.jmeter.protocol.nsp.processor.AbstractNSPPreProcessor;
import com.arosii.jmeter.protocol.nsp.sampler.AbstractNSPSoapSampler;

/**
 * 
 * @author Jacob
 */
public class DecouplingComponentPreProcessor extends AbstractNSPPreProcessor {

	private static final long serialVersionUID = 1L;

	/**
	 * {@inheritDoc}
	 */
	@Override
	public void process() {
		Sampler sampler = getThreadContext().getCurrentSampler();
		if (sampler instanceof AbstractNSPSoapSampler) {
			AbstractNSPSoapSampler soapSampler = (AbstractNSPSoapSampler) sampler;
			if (soapSampler.getSOAPAction() != null && soapSampler.getSOAPAction().length() > 0) {
				soapSampler.setSendSOAPAction(true);
				soapSampler.setPath("/decoupling");
			}
		}
	}
}
