/*
 * The contents of this file is the CONFIDENTAL and PROPRIETARY
 * property of Arosii Information Systems A/S. Any unauthorized use,
 * reproduction or transfer of this file is strictly prohibited.
 *
 * Copyright (C) 2012 Arosii Information Systems A/S.  All rights reserved.
 * This is an unpublished work, and is subject to limited
 * distribution and restricted disclosure only.
 */
package com.arosii.jmeter.protocol.gw.control.gui;

import java.awt.Component;

import org.apache.jmeter.gui.util.VerticalPanel;
import org.apache.jmeter.testelement.TestElement;

import com.arosii.jmeter.protocol.gw.sampler.GatewaySignIdCardRequestSampler;
import com.arosii.jmeter.protocol.sts.config.gui.IDCardConfigGui;
import com.arosii.jmeter.protocol.sts.control.STSIdentity.Type;

/**
 * 
 * @author Jacob Qvortrup
 */
public class GatewaySignIdCardRequestSamplerGui extends AbstractGWSamplerGui {

	private static final long serialVersionUID = 1L;

	private IDCardConfigGui idCardConfig;

	@Override
	public TestElement createTestElement() {
		GatewaySignIdCardRequestSampler sampler = new GatewaySignIdCardRequestSampler();
		modifyTestElement(sampler);
		return sampler;
	}

	@Override
	public String getLabelResource() {
		return "gw_sign_id_card";
	}

	@Override
	protected Component createConfigurationPanel() {
		final VerticalPanel configurationPanel = new VerticalPanel();
		appendIDCardPanel(configurationPanel);
		return configurationPanel;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public void configure(TestElement element) {
		super.configure(element);
		idCardConfig.configure(element);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public void modifyTestElement(TestElement element) {
		super.modifyTestElement(element);
		idCardConfig.modifyTestElement(element);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public void clearGui() {
		super.clearGui();
		idCardConfig.clearGui();
	}

	private void appendIDCardPanel(VerticalPanel configurationPanel) {
		idCardConfig = new IDCardConfigGui(Type.MOCES);
		configurationPanel.add(idCardConfig);
	}
}
