package com.arosii.jmeter.protocol.ihe.assertion.gui;

import java.awt.BorderLayout;
import java.awt.Component;

import org.apache.jmeter.assertions.gui.AbstractAssertionGui;
import org.apache.jmeter.testelement.TestElement;
import org.apache.jmeter.util.JMeterUtils;

import com.arosii.jmeter.resources.ihe.Messages;

public abstract class AbstractIHEAssertionGui extends AbstractAssertionGui {

	private static final long serialVersionUID = 1L;

	public AbstractIHEAssertionGui() {
		// Standard setup
		setLayout(new BorderLayout(0, 5));
		setBorder(makeBorder());
		add(makeTitlePanel(), BorderLayout.NORTH); // Add the standard title

		// Specific setup
		add(createConfigurationPanel(), BorderLayout.CENTER);
	}

	/**
	 * @return the configuration panel
	 */
	protected abstract Component createConfigurationPanel();

	/**
	 * {@inheritDoc}
	 */
	@Override
	public String getStaticLabel() {
		String label = Messages.getResString(getLabelResource());
		if (label == null || label.startsWith(JMeterUtils.RES_KEY_PFX)) {
			label = super.getStaticLabel();
		}
		return label;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public void modifyTestElement(TestElement element) {
		element.clear();
		configureTestElement(element);
	}
}
