package com.arosii.jmeter.protocol.ihe.control.gui;

import java.io.Serializable;

import org.apache.jmeter.testelement.AbstractTestElement;
import org.apache.jmeter.testelement.property.StringProperty;
import org.apache.jorphan.util.JOrphanUtils;

public class ClassificationCode extends AbstractTestElement implements Serializable {

	private static final long serialVersionUID = 240L;

	/** Name used to store the argument's name. */
	public static final String VALUE = "ClassificationCode.value"; // $NON-NLS-1$

	/** Name used to store the argument's value. */
	public static final String SCHEME = "ClassificationCode.scheme"; // $NON-NLS-1$

	/** Name used to store the argument's description. */
	public static final String DISPLAY_NAME = "ClassificationCode.display_name"; // $NON-NLS-1$

	public ClassificationCode() {
	}

	public ClassificationCode(String value, String scheme) {
		setProperty(new StringProperty(VALUE, value));
		setProperty(new StringProperty(SCHEME, scheme));
	}

	public ClassificationCode(String value, String scheme, String name) {
		setProperty(new StringProperty(VALUE, value));
		setProperty(new StringProperty(SCHEME, scheme));
		setProperty(new StringProperty(DISPLAY_NAME, name));
	}

	public void setDisplayName(String newName) {
		setProperty(new StringProperty(DISPLAY_NAME, newName));
	}

	public String getDisplayName() {
		return getPropertyAsString(DISPLAY_NAME);
	}

	public void setValue(String newValue) {
		setProperty(new StringProperty(VALUE, newValue));
	}

	public String getValue() {
		return getPropertyAsString(VALUE);
	}

	public void setScheme(String scheme) {
		setProperty(SCHEME, scheme);
	}

	public String getScheme() {
		return getPropertyAsString(SCHEME);
	}

	@Override
	public String toString() {
		return getName() + " (" + getValue() + " / " + getScheme() + ")";
	}

	public boolean isSkippable(String parameterName) {
		if (JOrphanUtils.isBlank(parameterName)) {
			return true; // Skip parameters with a blank name (allows use of optional variables in parameter lists)
		}
		// TODO: improve this test
		if (parameterName.trim().startsWith("${") && parameterName.endsWith("}")) {// $NON-NLS-1$ $NON-NLS-2$
			return true; // Missing variable name
		}
		return false;
	}
}
