/*
 * The contents of this file is the CONFIDENTAL and PROPRIETARY
 * property of Arosii Information Systems A/S. Any unauthorized use,
 * reproduction or transfer of this file is strictly prohibited.
 *
 * Copyright (C) 2012 Arosii Information Systems A/S.  All rights reserved.
 * This is an unpublished work, and is subject to limited
 * distribution and restricted disclosure only.
 */
package com.arosii.jmeter.protocol.ihe.control.gui;

import org.apache.jmeter.config.Argument;
import org.apache.jmeter.config.gui.ArgumentsPanel;
import org.apache.jmeter.gui.util.HeaderAsPropertyRenderer;
import org.apache.jmeter.util.JMeterUtils;
import org.apache.jorphan.gui.ObjectTableModel;
import org.apache.jorphan.reflect.Functor;

import com.arosii.jmeter.resources.ihe.Messages;

public class ClassificationsPanel extends ArgumentsPanel {

	private static final long serialVersionUID = 1L;

	public ClassificationsPanel(String label) {
		super(label, true);
		getTable().getTableHeader().setDefaultRenderer(new HeaderAsPropertyRenderer() {

			private static final long serialVersionUID = 1L;

			/**
			 * {@inheritDoc}
			 */
			@Override
			protected String getText(Object value, int row, int column) {
				String text = Messages.getResString(value.toString());
				if (text == null || text.startsWith(JMeterUtils.RES_KEY_PFX)) {
					text = super.getText(value, row, column);
				}
				return text;
			}
		});

	}

	@Override
	protected void initializeTableModel() {
		String[] headers = new String[] { "ihe_iti18_classifications_code", "ihe_iti18_classifications_scheme", COLUMN_RESOURCE_NAMES_2 };
		Functor[] read = new Functor[] { new Functor("getName"), new Functor("getValue"), new Functor("getDescription") };
		Functor[] write = new Functor[] { new Functor("setName"), new Functor("setValue"), new Functor("setDescription") };
		Class<?>[] classes = new Class[] { String.class, String.class, String.class };
		tableModel = new ObjectTableModel(headers, Argument.class, read, write, classes);
	}

}