package com.arosii.jmeter.protocol.ihe.cxf;

import java.io.InputStream;

import org.apache.cxf.binding.soap.SoapMessage;
import org.apache.cxf.binding.soap.interceptor.AbstractSoapInterceptor;
import org.apache.cxf.interceptor.Fault;
import org.apache.cxf.phase.Phase;
import org.apache.jmeter.threads.JMeterContext;

import com.arosii.jmeter.protocol.ihe.io.ContentCollectorInputStream;

public class ContentCollectorInInterceptor extends AbstractSoapInterceptor {

	private final JMeterContext jMeterContext;

	public ContentCollectorInInterceptor(JMeterContext jMeterContext) {
		super(Phase.PRE_STREAM);
		this.jMeterContext = jMeterContext;
	}

	@Override
	public void handleMessage(SoapMessage message) throws Fault {
		InputStream in = message.getContent(InputStream.class);
		ContentCollectorInputStream contentCollectorInputStream = new ContentCollectorInputStream(in);
		jMeterContext.getVariables().putObject(ContentCollectorInputStream.class.getName(), contentCollectorInputStream);
		message.setContent(InputStream.class, contentCollectorInputStream);
	}
}