package com.arosii.jmeter.protocol.ihe.cxf;

import java.io.OutputStream;

import org.apache.cxf.binding.soap.SoapMessage;
import org.apache.cxf.binding.soap.interceptor.AbstractSoapInterceptor;
import org.apache.cxf.interceptor.Fault;
import org.apache.cxf.phase.Phase;
import org.apache.jmeter.threads.JMeterContext;

import com.arosii.jmeter.protocol.ihe.io.ContentCollectorOutputStream;

public class ContentCollectorOutInterceptor extends AbstractSoapInterceptor {

	private final JMeterContext jMeterContext;

	public ContentCollectorOutInterceptor(JMeterContext jMeterContext) {
		super(Phase.PRE_STREAM);
		this.jMeterContext = jMeterContext;
	}

	@Override
	public void handleMessage(SoapMessage message) throws Fault {
		OutputStream out = message.getContent(OutputStream.class);
		ContentCollectorOutputStream contentCollectorOutputStream = new ContentCollectorOutputStream(out);
		jMeterContext.getVariables().putObject(ContentCollectorOutputStream.class.getName(), contentCollectorOutputStream);
		message.setContent(OutputStream.class, contentCollectorOutputStream);
	}
}