package com.arosii.jmeter.protocol.ihe.io;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;

public class ContentCollectorInputStream extends InputStream {

	private ByteArrayOutputStream content = new ByteArrayOutputStream();

	private final InputStream delegate;

	public ContentCollectorInputStream(InputStream delegate) {
		this.delegate = delegate;
	}

	@Override
	public int read() throws IOException {
		int b = delegate.read();
		content.write(b);
		return b;
	}
	
	@Override
	public void close() throws IOException {
		delegate.close();
	}
	
	public String content() throws IOException {
		return new String(content.toByteArray(), "utf-8");
	}

}
