package com.arosii.jmeter.protocol.ihe.io;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.OutputStream;

public class ContentCollectorOutputStream extends OutputStream {

	private ByteArrayOutputStream content = new ByteArrayOutputStream();

	private final OutputStream delegate;

	public ContentCollectorOutputStream(OutputStream delegate) {
		this.delegate = delegate;
	}

	@Override
	public void write(int b) throws IOException {
		content.write(b);
		delegate.write(b);
	}

	@Override
	public void flush() throws IOException {
		delegate.flush();
	}

	@Override
	public void close() throws IOException {
		delegate.close();
	}

	public String content() throws IOException {
		return new String(content.toByteArray(), "utf-8");
	}

}
