package com.arosii.jmeter.protocol.ihe.sampler;

import java.io.UnsupportedEncodingException;

import org.openehealth.ipf.commons.ihe.xds.core.metadata.Document;
import org.openehealth.ipf.commons.ihe.xds.core.requests.ProvideAndRegisterDocumentSet;
import org.openehealth.ipf.commons.ihe.xds.core.responses.Response;

public class ITI41SampleResult extends IHESampleResult {

	private ProvideAndRegisterDocumentSet provideAndRegisterDocumentSet;
	private Response response;

	public ProvideAndRegisterDocumentSet getProvideAndRegisterDocumentSet() {
		return provideAndRegisterDocumentSet;
	}

	public void setProvideAndRegisterDocumentSet(ProvideAndRegisterDocumentSet provideAndRegisterDocumentSet, byte[] documentData) {
		this.provideAndRegisterDocumentSet = provideAndRegisterDocumentSet;
		for (Document document : provideAndRegisterDocumentSet.getDocuments()) {
			ITI41DocumentSampleResult documentResult = new ITI41DocumentSampleResult();
			documentResult.setSampleLabel(document.getDocumentEntry().getUniqueId());
			documentResult.setSuccessful(true);
			documentResult.setResponseCodeOK();
			try {
				documentResult.setSamplerData(new String(documentData, "utf-8"));
				documentResult.setDocument(new String(documentData, "utf-8"));
			} catch (UnsupportedEncodingException ignored) {
			}
			documentResult.setDataEncoding("utf-8");
			documentResult.setContentType("text/xml");
			addRawSubResult(documentResult);
		}
	}

	public Response getResponse() {
		return response;
	}

	public void setResponse(Response response) {
		this.response = response;
	}

}
