package com.arosii.jmeter.protocol.ihe.sampler;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.HashMap;
import java.util.Map;
import java.util.stream.Collectors;

import org.openehealth.ipf.commons.ihe.xds.core.requests.RetrieveDocumentSet;
import org.openehealth.ipf.commons.ihe.xds.core.responses.RetrievedDocument;
import org.openehealth.ipf.commons.ihe.xds.core.responses.RetrievedDocumentSet;

public class ITI43SampleResult extends IHESampleResult {

	private RetrieveDocumentSet retrieveDocumentSet;

	private RetrievedDocumentSet retrievedDocumentSet;

	private Map<String, String> documents = new HashMap<>();

	public RetrieveDocumentSet getRetrieveDocumentSet() {
		return retrieveDocumentSet;
	}

	public void setRetrieveDocumentSet(RetrieveDocumentSet retrieveDocumentSet) {
		this.retrieveDocumentSet = retrieveDocumentSet;
	}

	public RetrievedDocumentSet getRetrievedDocumentSet() {
		return retrievedDocumentSet;
	}

	public void setRetrievedDocumentSet(RetrievedDocumentSet retrievedDocumentSet) throws IOException {
		this.retrievedDocumentSet = retrievedDocumentSet;
		for (RetrievedDocument retrievedDocument : retrievedDocumentSet.getDocuments()) {
			InputStream documentStream = retrievedDocument.getDataHandler().getInputStream();
			String document = new BufferedReader(new InputStreamReader(documentStream)).lines().collect(Collectors.joining());
			documents.put(retrievedDocument.getRequestData().getDocumentUniqueId(), document);
			ITI43DocumentSampleResult documentResult = new ITI43DocumentSampleResult();
			documentResult.setSampleLabel(retrievedDocument.getRequestData().getDocumentUniqueId());
			documentResult.setSuccessful(true);
			documentResult.setResponseCodeOK();
			documentResult.setResponseData(document.getBytes("utf-8"));
			documentResult.setDocument(document);
			documentResult.setDataEncoding("utf-8");
			documentResult.setContentType("text/xml");
			addRawSubResult(documentResult);
		}
	}

	public String getDocument(String documentUniqueId) {
		return documents.get(documentUniqueId);
	}
}
