package com.arosii.jmeter.save.converters;

import org.apache.jmeter.save.converters.SampleResultConverter;

import com.arosii.jmeter.protocol.ihe.sampler.IHESampleResult;
import com.arosii.jmeter.protocol.ihe.sampler.ITI41DocumentSampleResult;
import com.arosii.jmeter.protocol.ihe.sampler.ITI43DocumentSampleResult;
import com.thoughtworks.xstream.mapper.Mapper;

public class IHESampleResultConverter extends SampleResultConverter {

	public IHESampleResultConverter(Mapper mapper) {
		super(mapper);
	}

	@Override
	@SuppressWarnings("rawtypes")
	public boolean canConvert(Class clazz) {
		return IHESampleResult.class.isAssignableFrom(clazz) || ITI41DocumentSampleResult.class.isAssignableFrom(clazz) || ITI43DocumentSampleResult.class.isAssignableFrom(clazz);
	}
	
}
