package dk.nsp.jmeter.protocol.skr.sampler;

import java.io.ByteArrayInputStream;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.apache.jmeter.protocol.http.sampler.HTTPSampleResult;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

import dk.sosi.seal.model.Reply;

public class GetPersonalDataCardRequestSampler extends AbstractSKRSampler {

	private static final DocumentBuilderFactory FACTORY = DocumentBuilderFactory.newInstance();

	public GetPersonalDataCardRequestSampler() {
		setPath("/skr/skr");
		setSendSOAPAction(true);
		setSOAPAction("http://stamkort.dk/fsk/2018/05/01#GetPersonalDataCard");
	}

	@Override
	protected void putReply(HTTPSampleResult sample) {
		String responseData = sample.getResponseDataAsString().replaceAll("(Created>[\\d]{4}-[\\d]{2}-[\\d]{2}T[\\d]{2}:[\\d]{2}:[\\d]{2})\\.000(Z<)", "$1$2");
		sample.setResponseData(responseData, "utf-8");
		super.putReply(sample);
	}

	@Override
	protected Document createRequestBody() {
		try {
			DocumentBuilder builder = FACTORY.newDocumentBuilder();
			Document document = builder.newDocument();
			Element getPersonalDataCardRequestElement = document.createElementNS("http://stamkort.dk/fsk/2018/05/01/", "GetPersonalDataCardRequest");
			document.appendChild(getPersonalDataCardRequestElement);
			Element idElement = document.createElement("id");
			getPersonalDataCardRequestElement.appendChild(idElement);
			idElement.setAttribute("assigningAuthorityName", "CPR");
			idElement.setAttribute("extension", "0501792275");
			idElement.setAttribute("root", "1.2.208.176.1.2");
			return builder.parse(new ByteArrayInputStream("<ns:GetPersonalDataCardRequest xmlns:ns=\"http://stamkort.dk/fsk/2018/05/01/\"><id assigningAuthorityName=\"CPR\" extension=\"0501792275\" root=\"1.2.208.176.1.2\"/></ns:GetPersonalDataCardRequest>".getBytes()));
		} catch (Exception e) {
			throw new IllegalStateException(e);
		}
	}

	@Override
	protected void validateReply(HTTPSampleResult sample, Reply reply) {
		// TODO Auto-generated method stub

	}
}
