/*
 * The contents of this file is the CONFIDENTAL and PROPRIETARY
 * property of Arosii Information Systems A/S. Any unauthorized use,
 * reproduction or transfer of this file is strictly prohibited.
 *
 * Copyright (C) 2012 Arosii Information Systems A/S.  All rights reserved.
 * This is an unpublished work, and is subject to limited
 * distribution and restricted disclosure only.
 */
package com.arosii.jmeter.protocol.sor.sampler;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

public abstract class AbstractSORUpdateSampler extends AbstractSORSampler {

	private static final long serialVersionUID = 1L;

	protected AbstractSORUpdateSampler(String soapAction) {
	    super("/sor-opdatering/SOROpdateringService",
                "http://sundhedsdatastyrelsen.dk/SOROpdateringService/2018/09/06#" + soapAction);
	}

	protected Element initNewRequestElement(Document document, String elementName, String roleName) {
		Element request = document.createElementNS("http://sundhedsdatastyrelsen.dk/SOROpdateringService/2018/09/06/", elementName);
		document.appendChild(request);

		Element userElement = document.createElementNS("http://sundhedsdatastyrelsen.dk/SOROpdateringService/2018/09/06/", "User");
		request.appendChild(userElement);

		Element rolesElement = document.createElementNS("http://sundhedsdatastyrelsen.dk/SOROpdateringService/2018/09/06/", "Roles");
		userElement.appendChild(rolesElement);

		Element roleElement = document.createElementNS("http://sor.dksund.dk/", "sorSecurityGroupsExternal");
		roleElement.setTextContent(roleName);
		rolesElement.appendChild(roleElement);
		userElement.appendChild(rolesElement);

		Element entitiesElement = document.createElementNS("http://sundhedsdatastyrelsen.dk/SOROpdateringService/2018/09/06/", "Entities");
		userElement.appendChild(entitiesElement);

		Element entityElement = document.createElement("long");
		entityElement.setTextContent("0");
		entitiesElement.appendChild(entityElement);

		return request;
	}
}
