/*
 * The contents of this file is the CONFIDENTAL and PROPRIETARY
 * property of Arosii Information Systems A/S. Any unauthorized use,
 * reproduction or transfer of this file is strictly prohibited.
 *
 * Copyright (C) 2012 Arosii Information Systems A/S.  All rights reserved.
 * This is an unpublished work, and is subject to limited
 * distribution and restricted disclosure only.
 */
package com.arosii.jmeter.protocol.sts.control.gui;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.FlowLayout;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import org.apache.jmeter.gui.util.VerticalPanel;
import org.apache.jmeter.testelement.TestElement;

import com.arosii.jmeter.protocol.sts.sampler.SosiToOioSamlRequestSampler;
import com.arosii.jmeter.resources.sts.Messages;

/**
 * 
 * @author Jacob
 */
public class SosiToOioSamlRequestSamplerGui extends AbstractSTSSamplerGui {

	private static final long serialVersionUID = 1L;

	private JTextField audience;

	/**
	 * {@inheritDoc}
	 */
	@Override
	public String getLabelResource() {
		return "sts_sosi_to_oio_saml";
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public TestElement createTestElement() {
		SosiToOioSamlRequestSampler sampler = new SosiToOioSamlRequestSampler();
		modifyTestElement(sampler);
		return sampler;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	protected Component createConfigurationPanel() {
		final VerticalPanel configurationPanel = new VerticalPanel();
		appendAudiencePanel(configurationPanel);
		return configurationPanel;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public void configure(TestElement element) {
		super.configure(element);
		audience.setText(element.getPropertyAsString(SosiToOioSamlRequestSampler.AUDIENCE, ""));
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public void modifyTestElement(TestElement element) {
		super.modifyTestElement(element);
		element.setProperty(SosiToOioSamlRequestSampler.AUDIENCE, audience.getText());
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public void clearGui() {
		super.clearGui();
		audience.setText("");
	}

	private void appendAudiencePanel(VerticalPanel configurationPanel) {
		JPanel audiencePanel = new VerticalPanel();
		audiencePanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(), Messages.getResString("sts_audience")));
		audiencePanel.add(getAudiencePanel());
		configurationPanel.add(audiencePanel);
	}

	private Component getAudiencePanel() {
		audience = new JTextField(40);
		JLabel label = new JLabel(Messages.getResString("sts_audience"));
		
		JPanel audiencePanel = new JPanel(new FlowLayout(FlowLayout.LEFT, 5, 0));
		audiencePanel.add(audience);

		JPanel panel = new JPanel(new BorderLayout(5, 0));
		panel.add(label, BorderLayout.WEST);
		panel.add(audiencePanel, BorderLayout.CENTER);

		return panel;
	}
}
