/*
 * The contents of this file is the CONFIDENTAL and PROPRIETARY
 * property of Arosii Information Systems A/S. Any unauthorized use,
 * reproduction or transfer of this file is strictly prohibited.
 *
 * Copyright (C) 2012 Arosii Information Systems A/S.  All rights reserved.
 * This is an unpublished work, and is subject to limited
 * distribution and restricted disclosure only.
 */
package com.arosii.jmeter.protocol.sts.sampler;

import java.io.File;
import java.util.Properties;

import com.arosii.jmeter.protocol.nsp.sampler.AbstractNSPSoapSampler;

import dk.sosi.seal.model.SignatureUtil;
import dk.sosi.seal.vault.ClasspathCredentialVault;
import dk.sosi.seal.vault.CredentialVault;
import dk.sosi.seal.vault.FileBasedCredentialVault;
import dk.sosi.seal.vault.GenericCredentialVault;

/**
 * 
 * @author Jacob
 */
public abstract class AbstractSTSSoapSampler extends AbstractNSPSoapSampler {

	private static final long serialVersionUID = 1L;

	protected static CredentialVault getVaultFromFile(String path, String password) {
		final Properties properties = SignatureUtil.setupCryptoProviderForJVM();
		File file = new File(path);
		if (path.endsWith(".pkcs12") || path.endsWith(".p12")) {
			GenericCredentialVault vault = new GenericCredentialVault(properties, password);
			if (file.isFile()) {
				vault.setSystemCredentialPair(file, password);
			} else {
				vault.setSystemCredentialPair(Thread.currentThread().getContextClassLoader().getResourceAsStream(path), password);
			}
			return vault;
		} else if (file.isFile()) {
			return new FileBasedCredentialVault(new Properties(), file, password);
		} else {
			return new ClasspathCredentialVault(properties, path, password);
		}
	}
}
