/*
 * The contents of this file is the CONFIDENTAL and PROPRIETARY
 * property of Arosii Information Systems A/S. Any unauthorized use,
 * reproduction or transfer of this file is strictly prohibited.
 *
 * Copyright (C) 2012 Arosii Information Systems A/S.  All rights reserved.
 * This is an unpublished work, and is subject to limited
 * distribution and restricted disclosure only.
 */
package com.arosii.nsp.performance;

import java.util.Properties;

import org.w3c.dom.Document;

import dk.sosi.seal.SOSIFactory;
import dk.sosi.seal.model.AuthenticationLevel;
import dk.sosi.seal.model.CareProvider;
import dk.sosi.seal.model.IDCard;
import dk.sosi.seal.model.SecurityTokenRequest;
import dk.sosi.seal.model.SignatureConfiguration;
import dk.sosi.seal.model.SignatureUtil;
import dk.sosi.seal.model.UserInfo;
import dk.sosi.seal.model.constants.IDValues;
import dk.sosi.seal.model.constants.SubjectIdentifierTypeValues;
import dk.sosi.seal.pki.SOSITestFederation;
import dk.sosi.seal.pki.SignatureProviderFactory;
import dk.sosi.seal.pki.impl.HashMapCertificateCache;
import dk.sosi.seal.vault.ClasspathCredentialVault;
import dk.sosi.seal.vault.CredentialVault;
import dk.sosi.seal.xml.XmlUtil;

/**
 * 
 * @author Jacob
 */
public class Test {

	public static void main(String[] args) {
		System.out.println(moces());
		System.out.println(voces());
	}

	protected static String moces() {
		CredentialVault vault = new ClasspathCredentialVault(SignatureUtil.setupCryptoProviderForJVM(), "jks/validMocesVault.jks", "!234Qwer");

		Properties props = new Properties(System.getProperties());
		props.setProperty(SOSIFactory.PROPERTYNAME_SOSI_VALIDATE, Boolean.toString(false));
		SOSIFactory sosiFactory = new SOSIFactory(new SOSITestFederation(new Properties(), new HashMapCertificateCache()), vault, props);

		SecurityTokenRequest request = sosiFactory.createNewSecurityTokenRequest();
		UserInfo userInfo = new UserInfo("1111111118", "Anders", "And", "aand@andeby.dk", "coolDuck", "DOCTOR", "19901");
		CareProvider careProvider = new CareProvider(SubjectIdentifierTypeValues.CVR_NUMBER, "19343634", "orgName");
		IDCard idcard = sosiFactory.createNewUserIDCard("SOSITEST", userInfo, careProvider, AuthenticationLevel.MOCES_TRUSTED_USER, null, null, null, null);

		request.setIDCard(idcard);

		Document doc = request.serialize2DOMDocument();

		SignatureConfiguration signatureConfiguration = new SignatureConfiguration(new String[] { IDValues.IDCARD }, IDValues.IDCARD, IDValues.id);
		SignatureUtil.sign(SignatureProviderFactory.fromCredentialVault(vault), doc, signatureConfiguration);

		String xml = XmlUtil.node2String(doc, false, true);
		return xml;
	}

	protected static String voces() {
		CredentialVault vault = new ClasspathCredentialVault(SignatureUtil.setupCryptoProviderForJVM(), "jks/validVocesVault.jks", "!234Qwer");

		Properties props = new Properties(System.getProperties());
		props.setProperty(SOSIFactory.PROPERTYNAME_SOSI_VALIDATE, Boolean.toString(false));
		SOSIFactory sosiFactory = new SOSIFactory(new SOSITestFederation(new Properties(), new HashMapCertificateCache()), vault, props);

		SecurityTokenRequest request = sosiFactory.createNewSecurityTokenRequest();
		CareProvider careProvider = new CareProvider(SubjectIdentifierTypeValues.CVR_NUMBER, "19343634", "orgName");
		IDCard idcard = sosiFactory.createNewSystemIDCard("SOSITEST", careProvider, AuthenticationLevel.VOCES_TRUSTED_SYSTEM, null, null, null, null);

		request.setIDCard(idcard);

		Document doc = request.serialize2DOMDocument();

//		SignatureConfiguration signatureConfiguration = new SignatureConfiguration(new String[] { IDValues.IDCARD }, IDValues.IDCARD, IDValues.id);
//		SignatureUtil.sign(SignatureProviderFactory.fromCredentialVault(vault), doc, signatureConfiguration);

		String xml = XmlUtil.node2String(doc, false, true);
		return xml;
	}
}
