#!/bin/bash

# Source the profile script which should contain the M3 variable
if [ -f ~/.nsp_perf_profile ]; then
	. ~/.nsp_perf_profile
fi

CWD=$1
COMPONENT=$2
TESTPLAN=$3
DISTRIBUTION=$4
NSP_HOST=$5
NSP_PORT=$6

pushd ${CWD}/tests/${COMPONENT} > /dev/null

if [ "${TESTPLAN}" = "pullpoint" ]; then
	if [ "${DISTRIBUTION}" = "pptest900-100" ]; then
		${M3}/mvn -q exec:java -Dexec.mainClass="dk.nsp.jmeter.protocol.nas.backgroundjob.NotificationBrokerBackgroundJob" -Dexec.args="http://${NSP_HOST}:${NSP_PORT}/notificationbroker TESTNAS-TOPIC-PERFORMANCE-01 idtype01 100 1000 3000 2500"
	else
		${M3}/mvn -q exec:java -Dexec.mainClass="dk.nsp.jmeter.protocol.nas.backgroundjob.NotificationBrokerBackgroundJob" -Dexec.args="http://${NSP_HOST}:${NSP_PORT}/notificationbroker TESTNAS-TOPIC-PERFORMANCE-01 idtype01 20 1000 3000 500"
	fi
else
	echo "No background job for testplan ${TESTPLAN}"
fi

popd